# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DeploymentExpense(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'total_expense': 'float',
        'compute_expense': 'float',
        'storage_expense': 'float',
        'network_expense': 'float',
        'additional_expense': 'float',
        'unit': 'CatalogItemResourceUpfrontPriceResponseUnit',
        'last_updated_time': 'datetime',
        'message': 'str',
        'code': 'str'
    }

    attribute_map = {
        'total_expense': 'totalExpense',
        'compute_expense': 'computeExpense',
        'storage_expense': 'storageExpense',
        'network_expense': 'networkExpense',
        'additional_expense': 'additionalExpense',
        'unit': 'unit',
        'last_updated_time': 'lastUpdatedTime',
        'message': 'message',
        'code': 'code'
    }

    def __init__(self, total_expense=None, compute_expense=None, storage_expense=None, network_expense=None, additional_expense=None, unit=None, last_updated_time=None, message=None, code=None):  # noqa: E501
        """DeploymentExpense - a model defined in Swagger"""  # noqa: E501
        self._total_expense = None
        self._compute_expense = None
        self._storage_expense = None
        self._network_expense = None
        self._additional_expense = None
        self._unit = None
        self._last_updated_time = None
        self._message = None
        self._code = None
        self.discriminator = None
        if total_expense is not None:
            self.total_expense = total_expense
        if compute_expense is not None:
            self.compute_expense = compute_expense
        if storage_expense is not None:
            self.storage_expense = storage_expense
        if network_expense is not None:
            self.network_expense = network_expense
        if additional_expense is not None:
            self.additional_expense = additional_expense
        if unit is not None:
            self.unit = unit
        if last_updated_time is not None:
            self.last_updated_time = last_updated_time
        if message is not None:
            self.message = message
        if code is not None:
            self.code = code

    @property
    def total_expense(self):
        """Gets the total_expense of this DeploymentExpense.  # noqa: E501

        Total expense of the resource.  # noqa: E501

        :return: The total_expense of this DeploymentExpense.  # noqa: E501
        :rtype: float
        """
        return self._total_expense

    @total_expense.setter
    def total_expense(self, total_expense):
        """Sets the total_expense of this DeploymentExpense.

        Total expense of the resource.  # noqa: E501

        :param total_expense: The total_expense of this DeploymentExpense.  # noqa: E501
        :type: float
        """

        self._total_expense = total_expense

    @property
    def compute_expense(self):
        """Gets the compute_expense of this DeploymentExpense.  # noqa: E501

        Compute expense of the resource.  # noqa: E501

        :return: The compute_expense of this DeploymentExpense.  # noqa: E501
        :rtype: float
        """
        return self._compute_expense

    @compute_expense.setter
    def compute_expense(self, compute_expense):
        """Sets the compute_expense of this DeploymentExpense.

        Compute expense of the resource.  # noqa: E501

        :param compute_expense: The compute_expense of this DeploymentExpense.  # noqa: E501
        :type: float
        """

        self._compute_expense = compute_expense

    @property
    def storage_expense(self):
        """Gets the storage_expense of this DeploymentExpense.  # noqa: E501

        Storage expense of the resource.  # noqa: E501

        :return: The storage_expense of this DeploymentExpense.  # noqa: E501
        :rtype: float
        """
        return self._storage_expense

    @storage_expense.setter
    def storage_expense(self, storage_expense):
        """Sets the storage_expense of this DeploymentExpense.

        Storage expense of the resource.  # noqa: E501

        :param storage_expense: The storage_expense of this DeploymentExpense.  # noqa: E501
        :type: float
        """

        self._storage_expense = storage_expense

    @property
    def network_expense(self):
        """Gets the network_expense of this DeploymentExpense.  # noqa: E501

        Network expense of the resource.  # noqa: E501

        :return: The network_expense of this DeploymentExpense.  # noqa: E501
        :rtype: float
        """
        return self._network_expense

    @network_expense.setter
    def network_expense(self, network_expense):
        """Sets the network_expense of this DeploymentExpense.

        Network expense of the resource.  # noqa: E501

        :param network_expense: The network_expense of this DeploymentExpense.  # noqa: E501
        :type: float
        """

        self._network_expense = network_expense

    @property
    def additional_expense(self):
        """Gets the additional_expense of this DeploymentExpense.  # noqa: E501

        Additional expense incurred for the resource.  # noqa: E501

        :return: The additional_expense of this DeploymentExpense.  # noqa: E501
        :rtype: float
        """
        return self._additional_expense

    @additional_expense.setter
    def additional_expense(self, additional_expense):
        """Sets the additional_expense of this DeploymentExpense.

        Additional expense incurred for the resource.  # noqa: E501

        :param additional_expense: The additional_expense of this DeploymentExpense.  # noqa: E501
        :type: float
        """

        self._additional_expense = additional_expense

    @property
    def unit(self):
        """Gets the unit of this DeploymentExpense.  # noqa: E501


        :return: The unit of this DeploymentExpense.  # noqa: E501
        :rtype: CatalogItemResourceUpfrontPriceResponseUnit
        """
        return self._unit

    @unit.setter
    def unit(self, unit):
        """Sets the unit of this DeploymentExpense.


        :param unit: The unit of this DeploymentExpense.  # noqa: E501
        :type: CatalogItemResourceUpfrontPriceResponseUnit
        """

        self._unit = unit

    @property
    def last_updated_time(self):
        """Gets the last_updated_time of this DeploymentExpense.  # noqa: E501

        Last expense sync time.  # noqa: E501

        :return: The last_updated_time of this DeploymentExpense.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_time

    @last_updated_time.setter
    def last_updated_time(self, last_updated_time):
        """Sets the last_updated_time of this DeploymentExpense.

        Last expense sync time.  # noqa: E501

        :param last_updated_time: The last_updated_time of this DeploymentExpense.  # noqa: E501
        :type: datetime
        """

        self._last_updated_time = last_updated_time

    @property
    def message(self):
        """Gets the message of this DeploymentExpense.  # noqa: E501

        Expense sync message if any.  # noqa: E501

        :return: The message of this DeploymentExpense.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this DeploymentExpense.

        Expense sync message if any.  # noqa: E501

        :param message: The message of this DeploymentExpense.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def code(self):
        """Gets the code of this DeploymentExpense.  # noqa: E501

        Expense sync message code if any.  # noqa: E501

        :return: The code of this DeploymentExpense.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this DeploymentExpense.

        Expense sync message code if any.  # noqa: E501

        :param code: The code of this DeploymentExpense.  # noqa: E501
        :type: str
        """

        self._code = code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeploymentExpense, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeploymentExpense):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
